/*  n_threshold.c */

/* 	Copyright 2004-2005 Oswaldo Morizaki Hirakata */

/* 	This file is part of ga-nn-ag.

    ga-nn-ag is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn-ag is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn-ag; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "my_header.h"
#include "aux_prot.h"

/* 
0 = linear;
1 = sigmoid
2 = senoid

*/

double n_threshold(int threshold_type, float net)
{
	double temp;
	double temp1;

	switch(threshold_type)
	{
		case 0: temp=net; break;
		case 1: {
							exp(-net);  //required for bug gcc 3.3.2 Fedora Core 1
							temp1 = 1+exp(-net);
							temp = 1/temp1;
							break;
						}
/*		case 2: {
							temp1 = (net > 1.0) ? 1.0 : net;
							temp1 = (temp1 < 0) ? 0.0 : temp;
							temp1 = PI*temp1 - PI/2.0;
							temp = sin(temp1)/2 + 0.5;
							break;
						}
*/
	}
	return( temp > 1.0 ? 1.0 : temp < 0 ? 0 : temp);
}
